/*
Copyright (C) 2017-2018 Nikita Tseykovets <tseikovets@rambler.ru>

    This file is part of the Basilisk eye.

The Basilisk eye is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

The Basilisk eye is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the Basilisk eye in "license.txt". If not, see <https://www.gnu.org/licenses/gpl.html>.
*/

//    - main.t
//    

//   
class genRoom: room
	isVisited = nil
	number = 0
	type = 0
	description = ''
	passages = ''
	walls = ''
	sdesc = ""
	ldesc = "<<self.description>>\n<<self.passages>>\n<<self.walls != '' ? '  :\n<i>' + self.walls + '</i>' : ''>>"
	listendesc =
	{
		local content := self.contents, ind := 1, len := length(content), enemyCheck := nil, passages, directs := [];
		//      
		for(ind; ind <= len; ind++)
		{
			if(content[ind].enemy)
			{
				enemyCheck := true;
				break;
			}
		}
		if(enemyCheck)
		{
			"    -      . ";
			return;
		}
		//    
		passages := getVerPassages(self);
		len := length(passages)/2;
		for(ind := 1; ind <= len; ind++)
		{
			local i := 1, n;
			content := passages[ind*2].contents;
			n := length(content);
			//      
			for(i; i <= n; i++)
			{
				if(content[i].enemy)
				{
					enemyCheck := true;
					break;
				}
			}
			if(enemyCheck)
			{
				directs := directs + passages[ind*2 - 1];
				enemyCheck := nil;
			}
		}
		len := length(directs);
		"  ";
		if(len = 0)
		{
			",       . ";
			return;
		}
		if(len = 1)
		{
			"   - ,   <a href='<<directs[1]>>'><<directs[1]>></a>. ";
			return;
		}
		if(len = 2)
		{
			"   - ,   <a href='<<directs[1]>>'><<directs[1]>></a>  <a href='<<directs[2]>>'><<directs[2]>></a>. ";
			return;
		}
		if(len = 3)
		{
			"   - ,   <a href='<<directs[1]>>'><<directs[1]>></a>, <a href='<<directs[2]>>'><<directs[2]>></a>  <a href='<<directs[3]>>'><<directs[3]>></a>. ";
			return;
		}
		if(len = 4)
		{
			"   - ,   <a href='<<directs[1]>>'><<directs[1]>></a>, <a href='<<directs[2]>>'><<directs[2]>></a>, <a href='<<directs[3]>>'><<directs[3]>></a>  <a href='<<directs[4]>>'><<directs[4]>></a>. ";
			//return;
		}
	}
	noexit =
	{
		if(parserGetMe().isIn(startroom))
			return nil;
		else
			pass noexit;
	}
	leaveRoom(actor) =
	{
		self.isseen := nil;
		pass leaveRoom;
	}
	up =
	{
		if(self = global.respawnProtagonist)
		{
			if(eye.location = parserGetMe())
			{
				"\t ,     ,        .\n
					\t... ...   ...\n
					\t         .     .\n
					\t ׸,  <<parserGetMe().isHer ? " " : " ">>!..\n
					\t , ,   .\n
					       .      ,      .    <<parserGetMe().isHer ? "" : "">>.\b
					<center><b>***</b></center>\n
					,   .   .";
				endGame(1);
			}
			else
			{
				"       .";
			}
		}
		else
		{
			pass up;
		}
	}
	out = thePassage.doEnter(parserGetMe())
	in = self.out
;

//      
class roomDecoration: fixeditem, floatingItem
	type = 0
	location =
	{
		local loc = theFloor.location;
		if(self.type = loc.type)
			return loc;
		else
			return nil;
	}
;

//  
class weapon: item
	isWeapon = true
	noun = '/1'
;

//  
class chest: keyedLockable, fixeditem
	sdesc = ""
	rdesc = ""
	ddesc = ""
	vdesc = ""
	tdesc = ""
	pdesc = ""
	ldesc = "      ."
	isListed = true
	isopen = nil
	islocked = true
	mykey = ''
	doUnlockWith(actor, io) =
	{
		if(io = self.mykey)
		{
			"<<ZAG(actor,&sdesc)>> <<actor.isHer ? "" : "">> <<self.vdesc>> <<io.tdesc>>. ";
			self.islocked := nil;
		}
		if (!(io = self.mykey))
			{"<<ZAG(io,&itnomdesc)>>  ";if (io.isThem) ""; else "";"  . ";}
	}
	noun = '' '' '' '' '' '#d' '#t' '' '' '' '' '' '#d' '#t' '' '' '' '' '#d' '#t' '' '' '' '' '' '#d' '#t'
	adjective = '' '' '' '' '' '' '' '' '' '' '' '' '' '' ''
	isHim = true
;

//  
key: keyItem
	ldesc = "<<ZAG(self, &sdesc)>>   ."
	noun = '/1' '/1' '/1' '/1'
	adjective = '/1'
	isHim = true
;

//  
pivot: item
	noun = '/1' '/1' '/1' '/1'
	isHim = true
;

//    
hole: qcontainer, fixeditem
	ldesc =
	{
		local len := length(self.contents);
		"<<self.ldescText>>";
		if(len > 0)
			",   <<len > 1 ? "" : "">> <<listcont(self)>>.";
		else
			". ";
	}
	noun = '/1' '/1' '/1' '/1' '/1'
;

//  
class mushroom: fooditem
	sdesc = ""
	rdesc = ""
	ddesc = ""
	vdesc = ""
	tdesc = ""
	pdesc = ""
	ldesc = "    ."
	touchdesc = "     ."
	smelldesc = "      - ."
	isEquivalent = true
	pluraldesc = ""
	rpluraldesc = ""
	health = 0
	verDoEat(actor) =
	{
		if(parserGetMe().health >= 50)
			"   ,       ,     . ";
	}
	doEat(actor) =
	{
	local value := parserGetMe().health + self.health;
		" , , ...\n   <<self.health>>  . ";
		global.achievementMushrooms := global.achievementMushrooms + 1;
		if(value > 50)
		{
			"      50,      . ";
			global.achievementMushroomsValue := global.achievementMushroomsValue + self.health - (value - 50);
			parserGetMe().health := 50;
		}
		else
		{
			parserGetMe().health := value;
			global.achievementMushroomsValue := global.achievementMushroomsValue + self.health;
		}
		delete self;
	}
	verDoDrink(actor) =
	{
		"  - .";
	}
	noun = '' '' '' '' '' '#d' '#t' '' '' '' '' '' '#d' '#t' '' '' '' '' '' '#d' '#t' '' '' '' '' '#d' '#t'
	adjective = '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' ''
	isHim = true
;

//   
class shit: fooditem
	sdesc = " "
	rdesc = " "
	ddesc = " "
	vdesc = " "
	tdesc = " "
	pdesc = " "
	ldesc = "    ."
	touchdesc = "    ."
	smelldesc = "    ,      ."
	isEquivalent = true
	pluraldesc = " "
	rpluraldesc = " "
	verDoEat(actor) =
	{
		if(parserGetMe().doping = 2)
			"    ,       .";
	}
	doEat(actor) =
	{
		actor.doping := 2;
		" , , ... !!!\n  . ";
		delete self;
	}
	verDoDrink(actor) =
	{
		"  - .";
	}
	noun = '' '' '' '' '' '#d' '#t' '' '' '' '' '' '#d' '#t'
	adjective = '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '#r' '#r'
;