/*
The MIT License (MIT)

Copyright (C) 2017-2018 Nikita Tseykovets <tseikovets@rambler.ru>

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

//     CYOA
//  0.7.5
//      advr.t
//  commandPrompt()      replace,       paraView().

//    :
// 1)   "", ""  ""        
//  ""     ,     CYOA  ,  

//   commandPrompt(),       
#ifdef USE_HTML_PROMPT
replace commandPrompt: function(code)
{
	paraView();
	"<font face='TADS-Input'>";
	"\b&gt;";
}
#endif /* USE_HTML_PROMPT */

//      para
paraView: function()
{
	local loc := parserGetMe().location;
	if(isclass(loc, para))
		loc.lookAround(true);
}

//   CYOA
class para: room
	turnsofar = true //        
	intro = "" //  ,        
	text = "" //   
	opt = [' ', startroom] //    
	ps = "" //  ,     
	// ,    
	ldesc =
	{
		local ind, options := length(self.opt)/2, string, n, commands := length(self.authorizedCommands);
		//   
		self.intro;
		"\b";
		//   
		do
		{
			//   
			self.text;
			"\b";
			//      
			"<banner id='options' align='bottom' border>";
			for(ind := 1; ind <= options; ind++)
			{
				"<<displayLink(cvtstr(ind), '\t<b>' + cvtstr(ind) + ':</b> ' + self.opt[2*ind - 1])>>";
				if(ind = options)
					"\b";
				else
					"\n";
			}
			//  
			self.ps;
			"</banner>";
				"\b";
			//   
			"<font face='TADS-Input'>&gt;";
			string := input();
			"</font>";
			n := cvtnum(string);
			if(n < 1 || n > options)
			{
				local command := nil, commandList;
				//     
				string := TrimLeft(string);
				//      
				if(string != '')
				{
					string := lower(string);
					string := loweru(string);
					string := dezyo(string);
				}
				//   
				for(ind := 1; ind <= commands; ind++)
				{
					local i, n;
					commandList := authorizedCommands[ind];
					n := length(commandList);
					//     
					for(i := 2; i <= n; i++)
					{
						if(string = commandList[i])
						{
							command := true;
							break;
						}
					}
					if(command)
						break;
				}
				if(command)
				{
					//   
					execCommand(parserGetMe(), commandList[1], nil, nil, nil, 0);
					"\b";
				}
				else
				{
					//  -
					if(substr(string, 1, 1) = '*' || substr(string, 1, 1) = '>')
						return nil;
					else
						"      1  <<cvtstr(options)>>.\b";
				}
				string := '';
			}
			else
			{
				if(self.turnsofar)
					global.turnsofar := global.turnsofar + 1;
				"<banner id='options' remove>";
				parserGetMe().travelTo(self.opt[2*n]);
			}
		}
		while (string = '');
	}
	//          ldesc
	enterRoom(actor) =
	{
		self.lookAround(true);
	}
//     
	authorizedCommands = [
		[quitVerb 'quit' '']
		[scoreVerb 'score' 'status' '' '']
		[saveVerb 'save' '' '' '' '' '' '']
		[restoreVerb 'restore' '' '' '']
		[scriptVerb 'script' '']
		[unscriptVerb 'unscript' '' '']
		[restartVerb 'restart' '']
		//[undoVerb 'undo' '' '' '']
		[linksVerb 'links' '']
		[HelpVerb 'help' '']
		[versionVerb 'version' '']
		[debugVerb 'debug' '' '']
		[notifyVerb 'notify' '' '' '' '' '' '']
	]
	sdesc = ""
;
