/*
Copyright (C) 2017-2018 Nikita Tseykovets <tseikovets@rambler.ru>

    This file is part of the Basilisk eye.

The Basilisk eye is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

The Basilisk eye is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the Basilisk eye in "license.txt". If not, see <https://www.gnu.org/licenses/gpl.html>.
*/

//    

//    
#define USE_HTML_STATUS //     HTML-TADS
#define USE_HTML_PROMPT //      
#define GENERATOR_INCLUDED //    

//      
#include <advr.t> //       
#include <gameinfo.t> //        
#include <stdr.t> //      
#include "libs/timekeeper.t" //     
#include <generator.t> //    
#include <errorru.t> //     
#include <extendr.t> //     
#include <patcher/index.t> //      RTADS
#include <spellchecker.t> //    
#include "libs/lexicon.t" //     
#include "libs/metadata.t" //      
#include "libs/cyoa_menu.t" //     CYOA

//  
#include "actors.t" //   
#include "classes.t" //   
#include "daemons.t" //   
#include "functions.t" //   
#include "maze.t" //   
#include "objects.t" //    
#include "verbs.t" //   

//     
getGameInfo: function
{
	return [
		'IFID' '5998BA21-DE55-4785-B2C4-915BBD8D8DCF'
		'Name' ' '
		'Headline' '       .'
		'Byline' '    (tseikovets@rambler.ru)'
		'HtmlByline' '    (<a href="mailto:tseikovets@rambler.ru?subject=TADS">tseikovets@rambler.ru</a>)'
		'AuthorEmail' '  <tseikovets@rambler.ru>'
		'HtmlAuthorEmail' '  &lt;<a href="mailto:tseikovets@rambler.ru?subject=TADS">tseikovets@rambler.ru</a>&gt;'
		'Url' 'http://www.tseykovets.ru/download/tads/basilisk_eye.zip'
		'Desc' ',   ,       ,           . ,    ,            ,     .    ,        .            .'
		'HtmlDesc' ',   ,       ,           . ,    ,            ,     .    ,        .            .'
		'Version' '2.2'
		'FirstPublished' '2017-08-10'
		'ReleaseDate' '2018-07-12'
		'Language' 'ru-RU'
		'Genre' ' Rogue-      RPG     .'
		'LicenseType' 'Freeware'
		'CopyingRules' 'No-Cost Only; Compilations Allowed'
		'PresentationProfile' 'Multimedia'
		'AgeRating' '16+'
		'Size' '<b>  :</b>  -       45-60   .'
	];
}

//    init()
replace init: function
{
#ifdef USE_HTML_STATUS
	//    
	if (systemInfo(__SYSINFO_SYSINFO) != true
		|| systemInfo(__SYSINFO_VERSION) < '2.2.4')
	{
		"\b\b\(!     TADS 
		2.2.4  . ,      
		.      , ,
		      . 
		  - ,   
		      TADS.\)\b\b";
	}
#endif
	commonInit(); //  
	randomize(); //    
	global.verbose := true; //  "" 
	introduction(); //  
	version.sdesc; //     
	setdaemon(turncount, nil); //    
	notify(pedestal, &lock, 0); //    
	global.rooms := []; //    
	global.bats := []; //    
	global.monkeys := []; //    
	global.mapDimension := 8; //   
	global.respawnProtagonist := ''; //   
	global.respawnAntagonist1 := ''; //    
	global.respawnAntagonist2 := ''; //    
	global.achievementPussyel := global.achievementHogin := global.achievementAirheadmir := nil; //  
	global.achievementBats := global.achievementMonkeys := global.achievementMushrooms := global.achievementMushroomsValue := 0; //  
	parserGetMe().location := bed; //   
	bed.lookAround(true); //   
	startroom.isseen := true;			 //    
	if(not global.restarting)
		"<font size='-1'>\b\t(          ,        <i><<displayLink('', '')>></i>,          (<<getArrayElement(getGameInfo(), 'HtmlAuthorEmail')>>).        ,    <<displayLink('*  ', ' (*)')>>,     ,         .)</font>";
	scoreStatus(0, 0); //   
	timekeeper.startTime := gettime()[9]; //    
}

//   introduction()    
replace introduction: function
{
	"<center><img src='media/16plus.png' alt='16+'>\n
		<font size='+1'>   ,    .</font></center>\b";
	"\t<<getArrayElement(getGameInfo(), 'HtmlDesc')>>\b";
}

//   version     
modify version
	sdesc =
	{
		"<font size='+3'><center><b><i><<getArrayElement(getGameInfo(), 'Name')>></i></b></center></font>\n
			<font size='+2'><center><<getArrayElement(getGameInfo(), 'Headline')>></center></font>\b";
		if(!self.isseen)
			"<font size='+1'>       <i><<displayLink('', '')>></i> ( ).\n
				   ,    <i><<displayLink('', '')>></i>.</font>\n
				       <i><<displayLink('', '')>></i>.</font>\b";
		"<font size='+1'><center><<getArrayElement(getGameInfo(), 'HtmlByline')>>\n
			 <<getArrayElement(getGameInfo(), 'Version')>>\n
			IFID <<getArrayElement(getGameInfo(), 'IFID')>></center></font>\b";
		"<hr align='center'>\b\b";
		self.isseen := true;
	}
	isseen = nil
;

startroom: room
	sdesc = " "
	ldesc =
	{
		"    .    ,    .";
		if(!self.isseen)
		{
			"\n     ,   -   :\n
			    ,    .     ,   -  .   , -      ,      .       ,     ,         ,     .";
			//    
			notify(self, &startGame, 1);
			//   
			mazeGen();
		}
	}
	startGame =
	{
		"\b\t , , , .  , , ...\n
		\t ! !   !\n
		\t  ?  !..";
		parserGetMe().travelTo(startMenu);
	}
	listendesc = "      ."
;

startMenu: para
	text = " ,    :"
	opt = [
		' :\n            ,    .', PussyelOpt,
		' :\n         ,     .', HoginOpt,
		' :\n       -,      .', AirheadmirOpt
	]
;

PussyelOpt: room
	sdesc = " "
	ldesc =
	{
		"\t  , ,       ?        ,      .\n
			\t  ?   ,   ,     ,      ,   .\n
			\t        :  -  -   ,       .\n
			  !       ?!      !     !    ,     !\n
			\t           ,  - .\b";
		Me.avatar := Pussyel;
		bow.moveInto(Me);
		sidebarVerb.sidebarDisplay;
		Me.isHim := nil;
		Me.isHer := true;
		global.respawnProtagonist.walls := '   .    !\n\t   .   ! .';
		chalk.moveInto(global.respawnProtagonist);
		Hogin.travelTo(global.respawnAntagonist1);
		Airheadmir.travelTo(global.respawnAntagonist2);
		daemons.run;
		parserGetMe().travelTo(global.respawnProtagonist);
		global.respawnProtagonist.listendesc;
	}
;

HoginOpt: room
	sdesc = " "
	ldesc =
	{
ball.moveInto(Me);
		"\t  , ,       ?        ,      .\n
			\t  ?   ,   ,     ,      ,   .\n
			\t        :      -   ,       .\n
			   !       ,  ?!  ,    .          .    ,     .          .\n
			\t           ,  - .\b";
		Me.avatar := Hogin;
		axe.moveInto(Me);
		sidebarVerb.sidebarDisplay;
		global.respawnProtagonist.walls := '  .    !\n\t,       ! .';
		chalk.moveInto(global.respawnProtagonist);
		Pussyel.travelTo(global.respawnAntagonist1);
		Airheadmir.travelTo(global.respawnAntagonist2);
		daemons.run;
		parserGetMe().travelTo(global.respawnProtagonist);
		global.respawnProtagonist.listendesc;
	}
;

AirheadmirOpt: room
	sdesc = " "
	ldesc =
	{
		"\t  , ,       ?        ,      .\n
			\t  ?   ,   ,     ,      ,   .\n
			\t        :       -.\n
			  !       ?!    .     !     ,     !     ,    ,      .\n
			\t           ,  - .\b";
		Me.avatar := Airheadmir;
		crystal.moveInto(Me);
		sidebarVerb.sidebarDisplay;
		global.respawnProtagonist.walls := '  .    !\n\t    !   ,    !';
		chalk.moveInto(global.respawnProtagonist);
		Pussyel.travelTo(global.respawnAntagonist1);
		Hogin.travelTo(global.respawnAntagonist2);
		daemons.run;
		parserGetMe().travelTo(global.respawnProtagonist);
		global.respawnProtagonist.listendesc;
	}
;