/*
Copyright (C) 2017 Nikita Tseykovets <tseikovets@rambler.ru>

    This file is part of the Basilisk eye.

The Basilisk eye is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

The Basilisk eye is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the Basilisk eye in "license.txt". If not, see <https://www.gnu.org/licenses/gpl.html>.
*/

//    - main.t
//    

daemons: object
	shitList = [] //   
	mushroomList = [] //  
	weaponList = [] //  
	enemyList = [] //  
	//   
	run =
	{
		if(parserGetMe().avatar = Pussyel)
		{
			if(rand(2) = 1)
			{
				notify(self, &HoginDaemon, 0);
				notify(self, &AirheadmirDaemon, 0);
			}
			else
			{
				notify(self, &AirheadmirDaemon, 0);
				notify(self, &HoginDaemon, 0);
			}
		}
		if(parserGetMe().avatar = Hogin)
		{
			if(rand(2) = 1)
			{
				notify(self, &PussyelDaemon, 0);
				notify(self, &AirheadmirDaemon, 0);
			}
			else
			{
				notify(self, &AirheadmirDaemon, 0);
				notify(self, &PussyelDaemon, 0);
			}
		}
		if(parserGetMe().avatar = Airheadmir)
		{
			if(rand(2) = 1)
			{
				notify(self, &PussyelDaemon, 0);
				notify(self, &HoginDaemon, 0);
			}
			else
			{
				notify(self, &HoginDaemon, 0);
				notify(self, &PussyelDaemon, 0);
			}
		}
		notify(self, &batsDaemon, 0);
		notify(self, &monkeysDaemon, 0);
	}
	// 
	PussyelDaemon =
	{
		updateLists(Pussyel.location);
		self.enemyList := self.enemyList - Pussyel;
		if(crossbow.location = Pussyel)
			behaviorOpponent(Pussyel, crossbow);
		else
			behaviorOpponent(Pussyel, bow);
	}
	HoginDaemon =
	{
		updateLists(Hogin.location);
		self.enemyList := self.enemyList - Hogin;
		if(largeAxe.location = Hogin)
			behaviorOpponent(Hogin, largeAxe);
		else
			behaviorOpponent(Hogin, axe);
	}
	AirheadmirDaemon =
	{
		updateLists(Airheadmir.location);
		self.enemyList := self.enemyList - Airheadmir;
		if(ball.location = Airheadmir)
			behaviorOpponent(Airheadmir, ball);
		else
			behaviorOpponent(Airheadmir, crystal);
	}
	batsDaemon =
	{
		local i := 1, n := length(global.bats);
		for(i; i <= n; i++)
		{
			updateLists(global.bats[i].location);
			self.enemyList := self.enemyList - global.bats - global.monkeys;
			behaviorMonster(global.bats[i]);
		}
	}
	monkeysDaemon =
	{
		local i := 1, n := length(global.monkeys);
		for(i; i <= n; i++)
		{
			updateLists(global.monkeys[i].location);
			self.enemyList := self.enemyList - global.bats - global.monkeys;
			behaviorMonster(global.monkeys[i]);
		}
	}
;

// ,   
updateLists: function(targetRoom)
{
	local i := 1, content := targetRoom.contents, n := length(content);
	//  
	daemons.shitList := daemons.mushroomList := daemons.weaponList := daemons.enemyList := [];
	//  
	for(i; i <= n; i++)
	{
		if(firstsc(content[i]) = shit)
			daemons.shitList := daemons.shitList + content[i];
		if(firstsc(content[i]) = mushroom)
			daemons.mushroomList := daemons.mushroomList + content[i];
		if(firstsc(content[i]) = weapon)
			daemons.weaponList := daemons.weaponList + content[i];
		if(content[i].enemy)
			daemons.enemyList := daemons.enemyList + content[i];
		if(parserGetMe().isIn(targetRoom))
			daemons.enemyList := daemons.enemyList + parserGetMe();
	}
}

//   
behaviorOpponent: function(actor, tool)
{
	local len, ind, passages, noVisit, number, loc;
	if(!find(actor.visits, actor.location))
		actor.visits := actor.visits + actor.location;
	if(length(daemons.shitList) > 0 && actor.doping = 1)
	{
		actor.doping := 2;
		daemons.shitList[1].moveInto(nil);
		if(parserGetMe().isIn(actor.location))
			"\n<<ZAG(actor, &sdesc)>>   - ,   <<actor.isHim ? "" : "">>  . ";
		return;
	}
	if(length(daemons.mushroomList) > 0)
	{
		actor.health := actor.health + daemons.mushroomList[1].health;
		if(parserGetMe().isIn(actor.location))
			"\n<<ZAG(actor, &sdesc)>>  ,   <<actor.isHim ? "" : "">> <<daemons.mushroomList[1].health>>  . ";
		daemons.mushroomList[1].moveInto(nil);
		return;
	}
	if((actor = Pussyel && tool != crossbow)
		|| (actor = Hogin && tool != largeAxe)
		|| (actor = Airheadmir && tool != ball))
	{
		local i := 1, n := length(daemons.weaponList), check := nil;
		for(i; i <= n; i++)
		{
			if(actor = Pussyel && daemons.weaponList[i] = crossbow)
			{
				check := true;
				break;
			}
			if(actor = Hogin && daemons.weaponList[i] = largeAxe)
			{
				check := true;
				break;
			}
			if(actor = Airheadmir && daemons.weaponList[i] = ball)
			{
				check := true;
				break;
			}
		}
		if(check)
		{
			daemons.weaponList[i].moveInto(actor);
			if(parserGetMe().isIn(actor.location))
				"\n<<ZAG(actor, &sdesc)>>  <<daemons.weaponList[i].vdesc>>. ";
			return;
		}
	}
	len := length(daemons.enemyList);
	if(len > 0)
	{
		attack(actor, daemons.enemyList[rand(len)], tool);
		return;
	}
	passages := getVerPassages(actor.location);
	len := length(passages)/2;
	noVisit := nil;
	for(ind := 1; ind <= len; ind++)
	{
		if(!find(actor.visits, passages[ind*2]))
		{
		loc := passages[ind*2];
		number := ind;
		noVisit := true;
		break;
		}
	}
	if(!noVisit)
	{
		number := rand(len);
		loc := passages[number*2];
	}
	actor.moveInto(loc);
	if(parserGetMe().isIn(loc))
	{
		"\n ";
		if(passages[number*2 - 1] = '')
			"<a href=''></a>";
		if(passages[number*2 - 1] = '')
			"<a href=''></a>";
		if(passages[number*2 - 1] = '')
			"<a href=''></a>";
		if(passages[number*2 - 1] = '')
			"<a href=''></a>";
		"    <<ZAG(actor, &sdesc)>>. ";
	}
}

//   
behaviorMonster: function(actor)
{
	local len := length(daemons.enemyList);
	if(len > 0)
	{
		attack(actor, daemons.enemyList[rand(len)], nil);
	}
	else
	{
		local passages := getVerPassages(actor.location), number, loc;
		len := length(passages)/2;
		number := rand(len);
		loc := passages[number*2];
		actor.moveInto(loc);
		if(parserGetMe().isIn(loc))
		{
			"\n ";
			if(passages[number*2 - 1] = '')
				"<a href=''></a>";
			if(passages[number*2 - 1] = '')
				"<a href=''></a>";
			if(passages[number*2 - 1] = '')
				"<a href=''></a>";
			if(passages[number*2 - 1] = '')
				"<a href=''></a>";
			"   <<firstsc(actor) = bat ? "" : "">> <<actor.sdesc>>. ";
		}
	}
}