/*
Copyright (C) 2017 Nikita Tseykovets <tseikovets@rambler.ru>

    This file is part of the Basilisk eye.

The Basilisk eye is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

The Basilisk eye is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the Basilisk eye in "license.txt". If not, see <https://www.gnu.org/licenses/gpl.html>.
*/

//    - main.t
//     

//     
endGame: function
{
	"\b<hr align='center'>\b";
	global.turnsofar := global.turnsofar + 1;
	scoreRank();
	timeRank();
	"\b: <<displayLink('', '')>>  ,  <<displayLink('', '')>>, <<displayLink('', '')>>.\n";
	while(true)
	{
		local resp;
		"\n,  <<displayLink('', '')>>, <<displayLink('', '')>>  <<displayLink('', '')>>: &gt;";
		resp := upper(input());
		resp := loweru(resp);
		if((resp = 'restore') || (resp = ''))
		{
			resp := askfile('  :', ASKFILE_PROMPT_OPEN, FILE_TYPE_SAVE);
			if(resp = nil)
				"  . ";
			else if(restore(resp))
				"  . ";
			else
			{
				parserGetMe().location.lookAround(true);
				scoreStatus(global.score, global.turnsofar);
				abort;
			}
		}
		else if((resp = 'restart') || (resp = ''))
		{
			scoreStatus(0, 0);
			restart();
		}
		else if((resp = 'exit') || (resp = ''))
		{
			terminate();
			quit();
			abort;
		}
	}
}

//  scoreFormat()      
replace scoreFormat: function(points, turns)
{
	local status := '';
	if(isclass(parserGetMe().location, genRoom))
		status := ': <b>' + cvtstr(Me.health) + '</b>, : <b>' + Me.dopingValue + '</b>, ';
	status := status + ': ' + cvtstr(turns);
	return status;
}

//  scoreRank()     
replace scoreRank: function
{
	"  <<global.turnsofar>> <<numok(global.turnsofar, '', '', '')>>.\n";
}

// ,      
getVerPassages: function(targetRoom)
{
	local desc := targetRoom.passages, passages := [];
	if(find(desc, ''))
		passages := passages + '' + targetRoom.north;
	if(find(desc, ''))
		passages := passages + '' + targetRoom.south;
	if(find(desc, ''))
		passages := passages + '' + targetRoom.east;
	if(find(desc, ''))
		passages := passages + '' + targetRoom.west;
	return passages;
}

// ,    
attack: function(aggressor, victim, tool)
{
	local overallAccuracy, damage;
	if(aggressor = victim)
	{
		"\n      .\b
			<center><b>***</b></center>\n
			 ,  .   ,   .";
		endGame();
	}
	//        -
	if(firstsc(aggressor) = bat || firstsc(aggressor) = monkey)
		overallAccuracy := aggressor.accuracy;
	else
		overallAccuracy := aggressor.accuracy + tool.accuracy;
	if(parserGetMe().isIn(aggressor.location))
		"\n<<ZAG(aggressor, &sdesc)>> <<glok(aggressor, '')>> <<victim.vdesc>>";
	//    
	if(rand(10) <= overallAccuracy)
	{
		//       -
		if(firstsc(aggressor) = bat || firstsc(aggressor) = monkey)
			damage := aggressor.power;
		else
			damage := tool.power*aggressor.doping;
		//  
		victim.health := victim.health - damage;
		//    
		if(victim.health > 0)
		{
			if(parserGetMe().isIn(aggressor.location))
			{
				"  <<glok(aggressor, 2, 1, '')>>";
				if(victim = parserGetMe())
					". ";
				else
					" <<victim.isHim ? "" : "">>. ";
				if(victim = Hogin || victim.avatar = Hogin)
					"\n\t   !  <<glok(victim, '')>> <<victim.sdesc>>. ";
				if((aggressor = Hogin || aggressor.avatar = Hogin) && (victim = Pussyel || victim.avatar = Pussyel))
				{
					"\n\t <<rand(2) = 1 ? "" : "">>,  !  <<glok(aggressor, '')>> <<aggressor.sdesc>>. ";
					return;
				}
				if((aggressor = Hogin || aggressor.avatar = Hogin) && (victim = Airheadmir || victim.avatar = Airheadmir))
				{
					"\n\t <<rand(2) = 1 ? "" : "">>, !  <<glok(aggressor, '')>> <<aggressor.sdesc>>. ";
					return;
				}
				if(aggressor = Hogin || aggressor.avatar = Hogin)
					"\n\t <<rand(2) = 1 ? "" : "">>, !  <<glok(aggressor, '')>> <<aggressor.sdesc>>. ";
			}
		}
		else
		{
			if(victim = parserGetMe())
			{
				"  .\b
					<center><b>***</b></center>\n
					 ,  .   .";
				endGame();
			}
			if(victim = Pussyel)
			{
				fallingOut(victim);
				PussyelCorpse.moveInto(Pussyel.location);
				unnotify(daemons, &PussyelDaemon);
				Pussyel.moveInto(nil);
			}
			if(victim = Hogin)
			{
				fallingOut(victim);
				HoginCorpse.moveInto(Hogin.location);
				unnotify(daemons, &HoginDaemon);
				Hogin.moveInto(nil);
			}
			if(victim = Airheadmir)
			{
				fallingOut(victim);
				AirheadmirCorpse.moveInto(Airheadmir.location);
				unnotify(daemons, &AirheadmirDaemon);
				Airheadmir.moveInto(nil);
			}
			if(firstsc(victim) = bat)
			{
				global.bats := global.bats - victim;
				victim.moveInto(nil);
			}
			if(firstsc(victim) = monkey)
			{
				local tmp := new monkeyCorpse;
				tmp.moveInto(victim.location);
				global.monkeys := global.monkeys - victim;
				victim.moveInto(nil);
			}
			if(parserGetMe().isIn(aggressor.location))
			{
				"  <<glok(aggressor, '')>> <<victim.isHim ? "" : "">>. ";
				if((aggressor = Hogin || aggressor.avatar = Hogin) && (victim = Pussyel || victim.avatar = Pussyel))
				{
					"\n\t   ,  !  <<glok(aggressor, '')>> <<aggressor.sdesc>>. ";
					return;
				}
				if((aggressor = Hogin || aggressor.avatar = Hogin) && (victim = Airheadmir || victim.avatar = Airheadmir))
				{
					"\n\t   , !  <<glok(aggressor, '')>> <<aggressor.sdesc>>. ";
					return;
				}
				if(aggressor = Hogin || aggressor.avatar = Hogin)
					"\n\t   , !  <<glok(aggressor, '')>> <<aggressor.sdesc>>. ";
			}
		}
	}
	else
	{
		if(parserGetMe().isIn(aggressor.location))
		{
			",  ";
			if(victim = parserGetMe())
				"<<parserGetMe().sdesc>> ";
			else
				"<<victim.isHim ? "" : "">> ";
			if(rand(2) = 1)
				"<<glok(victim, '')>>. ";
			else
				" <<glok(victim, '')>> . ";
			if(aggressor = Hogin || aggressor.avatar = Hogin)
				"\n\t   !  <<glok(aggressor, '')>> <<aggressor.sdesc>>. ";
		}
	}
}

//      
fallingOut: function(actor)
{
	local i := 1, content := actor.contents, n := length(content);
	for(i; i <= n; i++)
	{
		content[i].moveInto(actor.location);
	}
}

//     
deadlyEye: function(victim)
{
	if(victim = parserGetMe())
	{
		"         .    ,    ,         .\n
			      .  <<iao(parserGetMe())>> .\b
			<center><b>***</b></center>\n
			 ,  .   .";
		endGame();
	}
	else
	{
		if(victim = Pussyel)
		{
			fallingOut(victim);
			PussyelCorpse.moveInto(Pussyel.location);
			unnotify(daemons, &PussyelDaemon);
			Pussyel.moveInto(nil);
		}
		if(victim = Hogin)
		{
			fallingOut(victim);
			HoginCorpse.moveInto(Hogin.location);
			unnotify(daemons, &HoginDaemon);
			Hogin.moveInto(nil);
		}
		if(victim = Airheadmir)
		{
			fallingOut(victim);
			AirheadmirCorpse.moveInto(Airheadmir.location);
			unnotify(daemons, &AirheadmirDaemon);
			Airheadmir.moveInto(nil);
		}
		if(firstsc(victim) = bat)
		{
			global.bats := global.bats - victim;
			victim.moveInto(nil);
		}
		if(firstsc(victim) = monkey)
		{
			local tmp := new monkeyCorpse;
			tmp.moveInto(victim.location);
			global.monkeys := global.monkeys - victim;
			victim.moveInto(nil);
		}
		"  ";
		if(victim = Pussyel || victim = Hogin || victim = Airheadmir)
			"<<ZAG(victim, &ddesc)>>";
		else
			"<<victim.ddesc>>";
		"  . ";
		if(victim.isHim)
			"";
		else
			"Ÿ";
		"        ,  <<victim.isHim ? "" : "">> ,   . ";
		if(parserGetMe().avatar = Hogin && victim = Pussyel)
		{
			"\n\t   ,  !   . ";
			return;
		}
		if(parserGetMe().avatar = Hogin && victim = Airheadmir)
		{
			"\n\t   , !   . ";
			return;
		}
		if(parserGetMe().avatar = Hogin)
			"\n\t   , !   . ";
	}
}

//    
displayCharacteristics: function()
{
	local check = nil;
	"\n\t: <<Me.health>>;\n
		\t: <<Me.dopingValue>>;\n
		\t:\n";
	if(Me.avatar = Pussyel)
	{
		if(crossbow.location = Me)
		{
			"\t\t ( <<crossbow.power*Me.doping>>)\n";
			check := true;
		}
		if(bow.location = Me)
		{
		"\t\t ( <<bow.power*Me.doping>>)\n";
			check := true;
		}
	}
	if(Me.avatar = Hogin)
	{
		if(largeAxe.location = Me)
		{
			"\t\t ( <<largeAxe.power*Me.doping>>)\n";
			check := true;
		}
		if(axe.location = Me)
		{
		"\t\t ( <<axe.power*Me.doping>>)\n";
			check := true;
		}
	}
	if(Me.avatar = Airheadmir)
	{
		if(ball.location = Me)
		{
			"\t\t ( <<ball.power*Me.doping>>)\n";
			check := true;
		}
		if(crystal.location = Me)
		{
		"\t\t ( <<crystal.power*Me.doping>>)\n";
			check := true;
		}
	}
	if(!check)
			".\n";
}

/*
*  listcontgen()      .
*  2-4  rdesc   pluraldesc,
*        rdesc.
*         pluraldesc.
*/
replace listcontgen: function(obj, flags, indent)
{
	local i, count, tot, list, cur, disptot, prefix_count;

	/*
	 *   Get the list.  If the "obj" parameter is already a list, use it
	 *   directly; otherwise, list the contents of the object. 
	 */
	switch(datatype(obj))
	{
	case 2:
		/* it's an object - list its contents */
		list := obj.contents;

		/* 
		 *   if the CHECKVIS flag is specified, check to make sure the
		 *   contents of the object are visible; if they're not, don't
		 *   list anything 
		 */
		if ((flags & LCG_CHECKVIS) != 0)
		{
			local contvis;

			/* determine whether the contents are visible */
			contvis := (!isclass(obj, openable)
						|| (isclass(obj, openable) && obj.isopen)
						|| obj.contentsVisible);

			/* if they're not visible, don't list the contents */
			if (!contvis)
				return;
		}
		break;
		
	case 7:
		/* it's already a list */
		list := obj;
		break;

	default:
		/* ignore other types entirely */
		return;
	}

	/* count the items in the list */
	tot := length(list);

	/* we haven't displayed anything yet */
	count := 0;

	/* 
	 *   Count how many items we're going to display -- this may be fewer
	 *   than the number of items in the list, because some items might
	 *   not be listed at all (isListed = nil), and we'll list each group
	 *   of equivalent objects with a single display item (with a count of
	 *   the number of equivalent objets) 
	 */
	disptot := itemcnt(list);

	/* iterate through the list */
	for (i := 1 ; i <= tot ; ++i)
	{
		/* get the current object */
		cur := list[i];

		/* if this object is to be listed, figure out how to show it */
		if (cur.isListed)
		{
			/* presume there is only one such object (i.e., no equivalents) */
			prefix_count := 1;
			
			/*
			 *   if this is one of more than one equivalent items, list it
			 *   only if it's the first one, and show the number of such
			 *   items along with the first one 
			 */
			if (cur.isEquivalent)
			{
				local before, after;
				local j;
				local sc;

				/* get this object's superclass */
				sc := firstsc(cur);

				/* scan for other objects equivalent to this one */
				for (before := after := 0, j := 1 ; j <= tot ; ++j)
				{
					if (isIndistinguishable(cur, list[j]))
					{
						if (j < i)
						{
							/*
							 *   note that objects precede this one, and
							 *   then look no further, since we're just
							 *   going to skip this item anyway
							 */
							++before;
							break;
						}
						else
							++after;
					}
				}
				
				/*
				 *   if there are multiple such objects, and this is the
				 *   first such object, list it with the count prefixed;
				 *   if there are multiple and this isn't the first one,
				 *   skip it; otherwise, go on as normal 
				 */
				if (before = 0)
					prefix_count := after;
				else
					continue;
			}

			/* display the appropriate separator before this item */
			if ((flags & LCG_TALL) != 0)
			{
				local j;
				
				/* tall listing - indent to the desired level */
				"\n";
				for (j := 1; j <= indent; ++j)
					"\ \ \ ";
			}
			else
			{
				/* 
				 *   "wide" (paragraph-style) listing - add a comma, and
				 *   possibly "and", if this isn't the first item
				 */
				if (count > 0)
				{
					if (count+1 < disptot)
						", ";
					else if (count = 1)
						"  ";
					else
						"  ";
				}
			}
			
			/* list the object, along with the number of such items */
			if (prefix_count = 1)
			{
				/* there's only one object - show the singular description */
				if (global.vinpadcont) cur.vdesc; else cur.sdesc;
			}
			else
			{
				/* 
				 *   there are multiple equivalents for this object -
				 *   display the number of the items and the plural
				 *   description 
				 */

				local lastone = prefix_count;

				sayPrefixCount(prefix_count, cur); " ";

				while (lastone>20) lastone-=(lastone/10)*10;

		switch (lastone) 
		{
		  case 1: if (global.vinpadcont) cur.vdesc; else cur.sdesc; break;
		  case 2: 
		  case 3: 
 		  case 4: cur.pluraldesc; break;
		  default: cur.rpluraldesc;   
		}
			}
			
			/* show any additional information about the item */
			if (cur.isworn)
				" (<<yao(cur)>>) ";
			if (cur.islamp and cur.islit)
				" () ";

			/* increment the number of displayed items */
			++count;

			/* 
			 *   If this is a "tall" listing, and there's at least one item
			 *   contained inside the current item, list the item's
			 *   contents recursively, indented one level deeper.
			 *   
			 *   If the 'check visibility' flag is set, then only proceed
			 *   with the sublisting if the contents are listable.  
			 */
			if ((flags & LCG_RECURSE) != 0
				&& itemcnt(cur.contents) != 0
				&& ((flags & LCG_CHECKLIST) = 0 || contentsListable(cur)))

			{
				/* 
				 *   if this is a "wide" listing, show the contents in
				 *   parentheses 
				 */
				if ((flags & LCG_TALL) = 0)
				{
					if (cur.issurface)
						" (  <<parserGetMe().fmtYou>> <<glok(parserGetMe(),2,1,'')>>";
					else
						" (  ";
				}
				
				/* show the recursive listing, indented one level deeper */
				listcontgen(cur, flags, indent + 1);

				/* close the parenthetical, if we opened one */
				if ((flags & LCG_TALL) = 0)
					") ";
			}
		}
	}
}