/*
Copyright (C) 2017 Nikita Tseykovets <tseikovets@rambler.ru>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//     CYOA
//  0.5
//      advr.t
//  commandPrompt()      replace,       paraView().

//   commandPrompt(),       
#ifdef USE_HTML_PROMPT
replace commandPrompt: function(code)
{
	paraView();
	"<font face='TADS-Input'>";
	"\b&gt;";
}
#endif /* USE_HTML_PROMPT */

//      para
paraView: function()
{
	local loc := parserGetMe().location;
	if(isclass(loc, para))
		loc.lookAround(true);
}

//   CYOA
class para: room
	intro = "" //  ,        
	text = "" //   
	opt = [' ', startroom] //    
	ps = "" //  ,     
	// ,    
	ldesc =
	{
		local ind, options := length(self.opt)/2, string, n, commands := length(self.authorizedCommands);
		//   
		self.intro;
		"\b";
		//   
		do
		{
			//   
			self.text;
			"\b";
			//      
			"<banner id='options' align='bottom' border>";
			for(ind := 1; ind <= options; ind++)
			{
				"<<displayLink(cvtstr(ind), '\t<b>' + cvtstr(ind) + ':</b> ' + self.opt[2*ind - 1])>>";
				if(ind = options)
					"\b";
				else
					"\n";
			}
			//  
			self.ps;
			"</banner>";
			"\b";
			//   
			string := input();
			n := cvtnum(string);
			if(n < 1 || n > options)
			{
				local command := nil;
				//     
				string := TrimLeft(string);
				//      
				if(string != '')
				{
					string := lower(string);
					string := loweru(string);
					string := dezyo(string);
				}
				//   
				for(ind := 1; ind <= commands; ind++)
				{
					if(string = authorizedCommands[ind])
				{
					command := true;
					break;
				}
				}
				if(command)
				{
					//     
					parserReplaceCommand(string);
				}
				else
				{
					//  -
					if(substr(string, 1, 1) = '*' || substr(string, 1, 1) = '>')
						return nil;
					else
						"      1  <<cvtstr(options)>>.\b";
				}
				string := '';
			}
			else
			{
				global.turnsofar := global.turnsofar + 1;
				"<banner id='options' remove>";
				parserGetMe().travelTo(self.opt[2*n]);
			}
		}
		while (string = '');
	}
	//          ldesc
	enterRoom(actor) =
	{
		self.lookAround(true);
	}
//     
	authorizedCommands = [
		'quit', '',
		'score', 'status', '', '',
		'save', '', '', '', '', '', '',
		'restore', '', '', '',
		'script', '',
		'unscript', '', '',
		'restart', '',
		'undo', '', '', '',
		'links', '',
		'help', ''
	]
	sdesc = ""
;
