/*
Copyright (C) 2017 Nikita Tseykovets <tseikovets@rambler.ru>

    This file is part of the Basilisk eye.

The Basilisk eye is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

The Basilisk eye is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the Basilisk eye in "license.txt". If not, see <https://www.gnu.org/licenses/gpl.html>.
*/

//    

#define USE_HTML_STATUS //     HTML-TADS
#define USE_HTML_PROMPT //      
#define GENERATOR_INCLUDED //    

#include <advr.t> //       
#include "advr_bugfix.t" //    advr.t
#include <gameinfo.t> //        
#include <stdr.t> //     ,   
#include "libs/timekeeper.t" //     
#include "libs/cyoa_menu.t" //     CYOA
#include <generator.t> //    
#include <errorru.t> //     
#include <extendr.t> //      
#include <spellchecker.t> //      
#include "libs/lexicon.t" //     

#include "actors.t" //   
#include "classes.t" //   
#include "daemons.t" //   
#include "functions.t" //   
#include "maze.t" //   
#include "objects.t" //    
#include "verbs.t" //   

//     
getGameInfo: function
{
	return ['Name', ' ',
	'Byline', '    (tseikovets@rambler.ru)',
	'Desc', '       .',
	'Version', '1.0.1',
	'ReleaseDate', getGameInfoToday(),
	'Language', 'RU'];
}

//    init()
replace init: function
{
#ifdef USE_HTML_STATUS
	//    
	if (systemInfo(__SYSINFO_SYSINFO) != true
		|| systemInfo(__SYSINFO_VERSION) < '2.2.4')
	{
		"\b\b\(!     TADS 
		2.2.4  . ,      
		.      , ,
		      . 
		    ,   
		      TADS.\)\b\b";
	}
#endif
	commonInit(); //  
	randomize(); //    
	global.verbose := true; //  "" 
	introduction(); //  
	version.sdesc;				//     
	setdaemon(turncount, nil);		 //    
	notify(pedestal, &lock, 0); //    
	global.rooms := []; //    
	global.bats := []; //    
	global.monkeys := []; //    
	global.mapDimension := 15; //   
	global.respawnProtagonist := ''; //   
	global.respawnAntagonist1 := ''; //    
	global.respawnAntagonist2 := ''; //    
	parserGetMe().location := bed; //   
	bed.lookAround(true); //   
	startroom.isseen := true;			 //    
	scoreStatus(0, 0); //   
	para.authorizedCommands := para.authorizedCommands  + ''; //      CYOA
	timekeeper.startTime := gettime()[9]; //    
}

//   introduction()    
replace introduction: function
{
	"<center><img src='media/16plus.png' alt='16+'>\n
		<font size='+1'>   ,    .</font></center>\b";
	"\t,   ,       ,           . ,    ,            ,     .    ,        .            .";
}

//   version     
modify version
	sdesc =
	{
		"<font size='+3'><center><b><i><<getGameInfo()[2]>></i></b></center></font>\n
			<font size='+2'><center><<getGameInfo()[6]>></center></font>\b";
		if(!self.isseen)
			"<font size='+1'>       <i><<displayLink('', '')>></i> ( ).\n
				   ,    <i><<displayLink('', '')>></i>.</font>\b";
		"<font size='+1'><center>    (<<displayLink('mailto:tseikovets@rambler.ru?subject=TADS', 'tseikovets@rambler.ru')>>)\n
			 <<getGameInfo()[8]>>\n
			 : <<getGameInfo()[10]>></center></font>\b";
		if(!self.isseen)
			"(          ,        <i><<displayLink('', '')>></i>,           .        ,    <<displayLink('*  ', ' (*)')>>  <<displayLink('&gt;  ', ' (&gt;)')>>,     ,         .)\b";
		"<hr align='center'>\b\b";
		self.isseen := true;
	}
	isseen = nil
;

startroom: room
	sdesc = " "
	ldesc =
	{
		"    .    ,    .";
		if(!self.isseen)
		{
			"\n     ,   -   :\n
			    ,    .     ,   -  .   , -      ,      .       ,     ,         ,     .";
			//    
			notify(self, &startGame, 1);
			//   
			mazeGen();
		}
	}
	startGame =
	{
		"\b\t , , , .  , , ...\n
		\t ! !   !\n
		\t  ?  !..";
		parserGetMe().travelTo(startMenu);
	}
	listendesc = "      ."
;

startMenu: para
	text = " ,    :"
	opt = [
		' :\n            ,    .', PussyelOpt,
		' :\n         ,     .', HoginOpt,
		' :\n       -,      .', AirheadmirOpt
	]
;

PussyelOpt: room
	sdesc = " "
	ldesc =
	{
		"\t  , ,       ?        ,      .\n
			\t  ?   ,   ,     ,      ,   .\n
			\t        :  -  -   ,       .\n
			  !       ?!      !     !    ,     !\n
			\t           ,  - .\b";
		Me.avatar := Pussyel;
		bow.moveInto(Me);
		sidebarVerb.sidebarDisplay;
		Me.isHim := nil;
		Me.isHer := true;
		global.respawnProtagonist.walls := '   .    !\n\t   .   ! .';
		chalk.moveInto(global.respawnProtagonist);
		Hogin.travelTo(global.respawnAntagonist1);
		Airheadmir.travelTo(global.respawnAntagonist2);
		daemons.run;
		parserGetMe().travelTo(global.respawnProtagonist);
		global.respawnProtagonist.listendesc;
	}
;

HoginOpt: room
	sdesc = " "
	ldesc =
	{
		"\t  , ,       ?        ,      .\n
			\t  ?   ,   ,     ,      ,   .\n
			\t        :      -   ,       .\n
			   !       ,  ?!  ,    .          .    ,     .          .\n
			\t           ,  - .\b";
		Me.avatar := Hogin;
		axe.moveInto(Me);
		sidebarVerb.sidebarDisplay;
		global.respawnProtagonist.walls := '  .    !\n\t,       ! .';
		chalk.moveInto(global.respawnProtagonist);
		Pussyel.travelTo(global.respawnAntagonist1);
		Airheadmir.travelTo(global.respawnAntagonist2);
		daemons.run;
		parserGetMe().travelTo(global.respawnProtagonist);
		global.respawnProtagonist.listendesc;
	}
;

AirheadmirOpt: room
	sdesc = " "
	ldesc =
	{
		"\t  , ,       ?        ,      .\n
			\t  ?   ,   ,     ,      ,   .\n
			\t        :       -.\n
			  !       ?!    .     !     ,     !     ,    ,      .\n
			\t           ,  - .\b";
		Me.avatar := Airheadmir;
		crystal.moveInto(Me);
		sidebarVerb.sidebarDisplay;
		global.respawnProtagonist.walls := '  .    !\n\t    !   ,    !';
		chalk.moveInto(global.respawnProtagonist);
		Pussyel.travelTo(global.respawnAntagonist1);
		Hogin.travelTo(global.respawnAntagonist2);
		daemons.run;
		parserGetMe().travelTo(global.respawnProtagonist);
		global.respawnProtagonist.listendesc;
	}
;