/*
Copyright (C) 2017 Nikita Tseykovets <tseikovets@rambler.ru>

    This file is part of the Basilisk eye.

The Basilisk eye is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

The Basilisk eye is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the Basilisk eye in "license.txt". If not, see <https://www.gnu.org/licenses/gpl.html>.
*/

//    - main.t
//    

// ,  
mazeGen: function()
{
	local i := 1, n := global.mapDimension*global.mapDimension, selectedRoom, RoomsNeighbourhood, neighbor, tmpRoom, roomsVisited := [];
	//  n 
	for(i; i <= n; i++)
	{
		global.rooms := global.rooms + new genRoom;
		global.rooms[i].number := i;
	}
	//     -
	selectedRoom := getRoom(rand(global.mapDimension), rand(global.mapDimension));
	while(length(roomsVisited) != n)
	{
		RoomsNeighbourhood := getRoomsNeighbourhood(selectedRoom);
		neighbor := 2*rand(length(RoomsNeighbourhood)/2);
		tmpRoom := RoomsNeighbourhood[neighbor - 1];
		if(!tmpRoom.isVisited)
		{
			local direct := RoomsNeighbourhood[neighbor];
			tmpRoom.isVisited := true;
			roomsVisited := roomsVisited + tmpRoom.number;
			if(direct = 'n')
			{
				selectedRoom.north := tmpRoom;
				tmpRoom.south := selectedRoom;
			}
			if(direct = 's')
			{
				selectedRoom.south := tmpRoom;
				tmpRoom.north := selectedRoom;
			}
			if(direct = 'w')
			{
				selectedRoom.west := tmpRoom;
				tmpRoom.east := selectedRoom;
			}
			if(direct = 'e')
			{
				selectedRoom.east := tmpRoom;
				tmpRoom.west := selectedRoom;
			}
			tmpRoom.type := replica(idTypeRoom);
		}
		selectedRoom := tmpRoom;
	}
	//  
	for(i := 1; i <= n; i++)
	{
		global.rooms[i].description := getRoomDesc(global.rooms[i]);
		global.rooms[i].passages := getPassagesDesc(global.rooms[i]);
	}
	//     
	roomsVisited := global.rooms;
	//    
	global.respawnProtagonist := getRespawnProtagonist();
	roomsVisited := roomsVisited - global.respawnProtagonist;
	ladder.moveInto(global.respawnProtagonist);
	global.respawnProtagonist.description := global.respawnProtagonist.description + ' <a href=\'\'></a>    .';
	//     
	pedestal.moveInto(getRespawnPedestal());
	pedestal.location.description := pedestal.location.description + '     .';
	roomsVisited := roomsVisited - pedestal.location;
	//    
	global.respawnAntagonist1 := roomsVisited[rand(length(roomsVisited))];
	roomsVisited := roomsVisited - global.respawnAntagonist1;
	global.respawnAntagonist2 := roomsVisited[rand(length(roomsVisited))];
	roomsVisited := roomsVisited - global.respawnAntagonist2;
	//     
	for(i := 1; i <= 5; i++)
	{
		local tmp := new chest;
		tmp.moveInto(roomsVisited[rand(length(roomsVisited))]);
		roomsVisited := roomsVisited - tmp.location;
		replica(pivots).moveInto(tmp);
		tmp.mykey := replica(keys);
	}
	//     
	for(i := 1; i <= 5; i++)
	{
		local tmp := replica(keys);
		tmp.moveInto(roomsVisited[rand(length(roomsVisited))]);
		roomsVisited := roomsVisited - tmp.location;
	}
	//   
	crossbow.moveInto(roomsVisited[rand(length(roomsVisited))]);
	roomsVisited := roomsVisited - crossbow.location;
	largeAxe.moveInto(roomsVisited[rand(length(roomsVisited))]);
	roomsVisited := roomsVisited - largeAxe.location;
	ball.moveInto(roomsVisited[rand(length(roomsVisited))]);
	roomsVisited := roomsVisited - ball.location;
	//  50  
	for(i := 1; i <= 50; i++)
	{
		local tmp := new bat;
		global.bats := global.bats + tmp;
		tmp.moveInto(roomsVisited[rand(length(roomsVisited))]);
		roomsVisited := roomsVisited - tmp.location;
	}
	//  50  
	for(i := 1; i <= 50; i++)
	{
		local tmp := new monkey;
		global.monkeys := global.monkeys + tmp;
		tmp.moveInto(roomsVisited[rand(length(roomsVisited))]);
		roomsVisited := roomsVisited - tmp.location;
	}
	//  120 
	roomsVisited := global.rooms;
	for(i := 1; i <= 120; i++)
	{
		local tmp := new mushroom;
		tmp.moveInto(roomsVisited[rand(length(roomsVisited))]);
		tmp.health := rand(6) + 4;
		roomsVisited := roomsVisited - tmp.location;
	}
	//  10  - 
	for(i := 1; i <= 10; i++)
	{
		local tmp := new shit;
		tmp.moveInto(roomsVisited[rand(length(roomsVisited))]);
		roomsVisited := roomsVisited - tmp.location;
	}
}

// ,     
getRoomsNeighbourhood: function(targetRoom)
{
	local tmpR, tmpC, RoomsNeighbourhood := [];
	//   ()
	tmpR := getRoomR(targetRoom) - 1;
	tmpC := getRoomC(targetRoom);
	if(tmpR != 0)
		RoomsNeighbourhood := RoomsNeighbourhood + getRoom(tmpR, tmpC) + 'n';
	//   ()
	tmpR := tmpR + 2;
	if(tmpR != global.mapDimension + 1)
		RoomsNeighbourhood := RoomsNeighbourhood + getRoom(tmpR, tmpC) + 's';
	//   ()
	tmpR := tmpR - 1;
	tmpC := tmpC - 1;
	if(tmpC != 0)
		RoomsNeighbourhood := RoomsNeighbourhood + getRoom(tmpR, tmpC) + 'w';
	//   ()
	tmpC := tmpC + 2;
	if(tmpC != global.mapDimension + 1)
		RoomsNeighbourhood := RoomsNeighbourhood + getRoom(tmpR, tmpC) + 'e';
	return RoomsNeighbourhood;
}

// ,  r  
getRoomR: function(targetRoom)
{
	local remainder := targetRoom.number % global.mapDimension;
	if(remainder = 0)
		return targetRoom.number/global.mapDimension;
	else
		return targetRoom.number/global.mapDimension + 1;
}

// ,  c  
getRoomC: function(targetRoom)
{
	local remainder := targetRoom.number % global.mapDimension;
	if(remainder = 0)
		return global.mapDimension;
	else
		return remainder;
}

// ,    
getRoom: function(r, c)
{
	return global.rooms[(r - 1)*global.mapDimension + c];
}

//    
idTypeRoom: lexicon
	phrases = [1, 2, 3, 4, 5, 6, 7, 8]
;

// ,    
getRoomDesc: function(targetRoom)
{
	local id := targetRoom.type, desc;
	if(id = 1)
		desc := '      ,    .';
	if(id = 2)
		desc := '       .';
	if(id = 3)
		desc := '        .';
	if(id = 4)
		desc := '     ,     .';
	if(id = 5)
		desc := '     .';
	if(id = 6)
		desc := '    ,   ,      .';
	if(id = 7)
		desc := '  ,      .';
	if(id = 8)
		desc := ' ,   ,        .';
	return desc;
}

// ,     
getPassagesDesc: function(targetRoom)
{
	local desc, passages := getPassages(targetRoom), n := length(passages);
	desc := '    ';
	if(n = 2)
		desc := desc + '<a href="' + passages[1] + '">' + passages[1] + '</a>.';
	if(n = 4)
		desc := desc + '<a href="' + passages[1] + '">' + passages[1] + '</a>  <a href="' + passages[3] + '">' + passages[3] + '</a>.';
	if(n = 6)
		desc := desc + '<a href="' + passages[1] + '">' + passages[1] + '</a>, <a href="' + passages[3] + '">' + passages[3] + '</a>  <a href="' + passages[5] + '">' + passages[5] + '</a>.';
	if(n = 8)
		desc := desc + '<a href="' + passages[1] + '">' + passages[1] + '</a>, <a href="' + passages[3] + '">' + passages[3] + '</a>, <a href="' + passages[5] + '">' + passages[5] + '</a>  <a href="' + passages[7] + '">' + passages[7] + '</a>.';
	return desc;
}

// ,     
//    .    getVerPassages()
getPassages: function(targetRoom)
{
	local passage, passages := [];
	passage := targetRoom.north;
	if(passage)
		passages := passages + '' + passage;
	passage := targetRoom.south;
	if(passage)
		passages := passages + '' + passage;
	passage := targetRoom.east;
	if(passage)
		passages := passages + '' + passage;
	passage := targetRoom.west;
	if(passage)
		passages := passages + '' + passage;
	return passages;
}

// ,     
getRespawnProtagonist: function()
{
	local indent := 2, r, c;
	//   ,       indent
	r := rand(global.mapDimension - indent*2) + indent;
	if(r = 3 || r = (global.mapDimension - indent))
	{
		c := rand(global.mapDimension - indent*2) + indent;
	}
	else
	{
		if(rand(2) = 1)
			c := 1 + indent;
		else
			c := global.mapDimension - indent;
	}
	//  
	if(rand(2) = 1)
		return getRoom(r, c);
	else
		return getRoom(c, r);
}

// ,    
getRespawnPedestal: function()
{
	local indent := 2, r, c;
	//          
	r := c := global.mapDimension/2 - indent;
	//       
	r := r + rand(indent*2 + 1);
	c := c + rand(indent*2 + 1);
	return getRoom(r, c);
}