/*
Copyright (C) 2017 Nikita Tseykovets <tseikovets@rambler.ru>

    This file is part of the Basilisk eye.

The Basilisk eye is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

The Basilisk eye is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the Basilisk eye in "license.txt". If not, see <https://www.gnu.org/licenses/gpl.html>.
*/

//    - main.t
//     

//    ,    

theWall: readable, fixeditem, floatingItem
	desc = '/1'
	ldesc =
	{
		if(parserGetMe().location = bed)
			"  .";
		else
			"  <<theFloor.location.walls != '' ? ',   :\n<i>' + theFloor.location.walls + '</i>' : '.'>>";
	}
	readdesc =
	{
		if(theFloor.location.walls != '')
			"  :\n<i><<theFloor.location.walls>></i>";
		else
			"    .";
	}
	verDoClean(actor) =
	{
		if(theFloor.location.walls = '')
			"    ,      . ";
	}
	doClean(actor) =
	{
		"  ,  <<ok(actor, '', '', '', '')>>   . ";
		theFloor.location.walls := '';
	}
	noun = '/1' '/2' '/1' '/2' '/1' '/2' '/1' '/2'
	adjective = '/1' '/2' '/-' '/1' '/2' '/1' '/2'
	isHer = true
	location = parserGetMe().location
;

thePassage: fixeditem, floatingItem
	desc = '/1'
	ldesc = "   ."
	noun = '/1' '/2' '/1' '/2' '/1' '/2' '/1' '/1' '/1' '/1'
	adjective = '/1' '/1' '/1' '/1'
	isHim = true
	verDoEnter(actor) = {}
	doEnter(actor) =
	{
		"      , , <i>  </i>,   <i></i>,     <i></i>, <i></i>, <i></i>  <i></i>.";
	}
	location = parserGetMe().location
;

theCeiling: distantItem, floatingItem
	desc = '/1'
	ldesc =
	{
		if(parserGetMe().location = bed)
			"  .";
		else
			"     .";
	}
	noun = '/1' '/1'
	adjective = '/1' '/1' '/1' '/1'
	isHim = true
	location = parserGetMe().location
;

theRoom: fixeditem, floatingItem
	desc = '/1'
	ldesc = parserGetMe().location.lookAround(true)
	verDoEnter(actor) =
	{
		"   . ";
	}
	verDoUnboard(actor) = {}
	doUnboard(actor) =
	{
		parserGetMe().travelTo(theFloor.location.out);
	}
	noun = '/1' '/1' '/1' '/1' '/1' '/1' '/1' '/1' '/2' '/1' '/1'
	adjective = '/1' '/1' '/1' '/2' '/1' '/1' '/1' '/2' '/1' '/1' '/1' '/2' '/1' '/1' '/1' '/2' '/1' '/1' '/1' '/2' '/1' '/1' '/1' '/2' '/1' '/1' '/1' '/2' '/1'
	location = parserGetMe().location
;

//  

bed: beditem
	desc = '/1'
	ldesc = "  ."
	reachable = inherited.reachable + doctor
	verDoUnboard(actor) =
	{
		"    ,     .";
	}
	noun = '/1' '/1' '/1'
	adjective = '/1' '/1' '/1'
	isHer = true
	location = startroom
;

ladder: fixeditem
	desc = '/1'
	ldesc = "     ."
	noun = '/1' '/2' '/1'
	adjective = '/1' '/1'
	isHer = true
;

stalactite: roomDecoration
	type = 1
	desc = '/1'
	ldesc = "  ,     ."
	noun = '/1' '/2' '/1'
	adjective = '/1' '/1' '/2' '/1' '/1' '/2' '/1' '/1' '/2' '/1' '/1' '/2' '/-'
	isHim = true
;

stalagmite: roomDecoration
	type = 1
	desc = '/1'
	ldesc = "  ,     ."
	noun = '/1' '/1' '/1'
	adjective = '/1' '/1' '/2' '/1' '/1' '/2' '/1' '/1' '/2' '/1' '/1' '/2' '/-'
	isHim = true
;

stalagnate: roomDecoration
	type = 1
	desc = '/1'
	ldesc = "         ."
	noun = '/1' '/2' '/1'
	adjective = '/1' '/2' '/1'
	isHim = true
;

formations: roomDecoration
	type = 2
	desc = '/2 /2'
	ldesc = "     ."
	noun = '/2' '/1' '/1' '/2' '/1' '/2' '/1'
	adjective = '/2' '/1' '/2' '/1' '/2' '/1' '/1' '/1' '/1' '/2'
	isThem = true
;

deposits: roomDecoration
	type = 3
	desc = '/2 /2'
	ldesc = "     ."
	noun = '/2' '/1' '/2' '/1' '/2' '/1'
	adjective = '/2' '/1' '/2' '/1' '/2' '/1' '/1' '/1' '/2'
	isThem = true
;

waterfall: roomDecoration
	type = 4
	desc = '/1 /1'
	ldesc = "        ."
	noun = '/1' '/1' '/1' '/2' '/1'
	adjective = '/1' '/1' '/2' '/1' '/1' '/2' '/1' '/1' '/2' '/1' '/1' '/2'
	isHim = true
;

helictites: roomDecoration
	type = 5
	desc = '/2'
	ldesc = " ,     ."
	noun = '/2' '/1' '/2' '/1'
	adjective = '/2' '/1' '/-'
	isThem = true
;

boulder: roomDecoration
	type = 6
	desc = '/1'
	ldesc = "  ."
	noun = '/1' '/2' '/1' '/2' '/1' '/2'
	adjective = '/1' '/1' '/2' '/1' '/1' '/2' '/1' '/1' '/2' '/1' '/1'
	isHer = true
;

// 

bow: weapon
	desc = '/1'
	ldesc = "   .\n <<self.power>>."
	power = 4
	accuracy = 1
	verIoShootFrom(actor) =
	{
		if(actor.avatar != Pussyel)
			"     <<self.rdesc>>.     . ";
	}
	ioShootFrom(actor, dobj) =
	{
		"! ";
		attack(actor, dobj, self);
	}
	noun = '/1' '/1' '/2'
	adjective = '/1' '/1' '/2'
	isHim = true
	location = Pussyel
;

crossbow: weapon
	desc = '/1'
	ldesc = "     .\n <<self.power>>."
	power = 6
	accuracy = 3
	verIoShootFrom(actor) =
	{
		if(actor.avatar != Pussyel)
			"     <<self.rdesc>>.     . ";
	}
	ioShootFrom(actor, dobj) =
	{
		"! ";
		attack(actor, dobj, self);
	}
	noun = '/1' '/1' '/2'
	adjective = '/1' '/1' '/1' '/2' '/1' '/2'
	isHim = true
;

axe: weapon
	desc = '/1'
	ldesc = "   .\n <<self.power>>."
	power = 4
	accuracy = 2
	verIoAttackWith(actor) =
	{
		if(actor.avatar != Hogin)
			"    <<self.tdesc>>.     . ";
	}
	ioAttackWith(actor, dobj) =
	{
		"! ";
		attack(actor, dobj, self);
	}
	noun = '/1' '/1'
	adjective = '/1' '/1' '/1' '/1'
	isHim = true
	location = Hogin
;

largeAxe: weapon
	desc = '/1'
	ldesc = "  .\n <<self.power>>."
	power = 6
	accuracy = 4
	verIoAttackWith(actor) =
	{
		if(actor.avatar != Hogin)
			"    <<self.tdesc>>.     . ";
	}
	ioAttackWith(actor, dobj) =
	{
		"! ";
		attack(actor, dobj, self);
	}
	noun = '/1'
	adjective = '/1' '/1'
	isHer = true
;

crystal: weapon
	desc = '/1'
	ldesc = "     .\n <<self.power>>."
	power = 6
	accuracy = 1
	noun = '/1'
	adjective = '/1'
	isHim = true
	location = Airheadmir
;

ball: weapon
	desc = '/1'
	ldesc = "      .\n <<self.power>>."
	power = 8
	accuracy = 3
	noun = '/1' '/1'
	adjective = '/1' '/1'
;

// ,   

chalk: item
	desc = '/1 /-'
	ldesc = "   ."
	noun = '/1' '/1' '/1' '/1'
	adjective = '/1' '/1'
	isHim = true
;

goldKey: key
	desc = '/1 /1'
	adjective= '/1'
;

silverKey: key
	desc = '/1 /1'
	adjective = '/1'
;

copperKey: key
	desc = '/1 /1'
	adjective = '/1'
;

brassKey: key
	desc = '/1 /1'
	adjective = '/1'
;

ironKey: key
	desc = '/1 /1'
	adjective = '/1'
;

//    
keys: lexicon
	phrases = [
		goldKey,
		silverKey,
		copperKey,
		brassKey,
		ironKey
	]
;

goldPivot: pivot
	desc = '/1 /1'
	ldesc = "      ."
	noun = '/1'
	adjective = '/1' '/1'
;

silverPivot: pivot
	desc = '/1 /1'
	ldesc = "      ."
	noun = '/1'
	adjective = '/1' '/1'
;

copperPivot: pivot
	desc = '/1 /1'
	ldesc = "        ."
	noun = '/1'
	adjective = '/1' '/1' '/1' '/1'
;

brassPivot: pivot
	desc = '/1 /1'
	ldesc = "       ."
	noun = '/1'
	adjective = '/1' '/1' '/1'
;

ironPivot: pivot
	desc = '/1 /1'
	ldesc = "        ."
	noun = '/1'
	adjective = '/1' '/1' '/1' '/1'
;

//  
pivots: lexicon
	phrases = [
		goldPivot,
		silverPivot,
		copperPivot,
		brassPivot,
		ironPivot
	]
;

pedestal: surface, fixeditem
	desc = '/1 /1'
	ldesc = "  ,       ,    .<<eye.location = self ? "       ." : "">><<self.islocked ? "     ." : "">>"
	ioPutOn(actor, dobj) =
	{
		if(self.islocked)
		{
			"    ,       .";
			exit;
		}
		if(dobj != eye)
		{
			" <<self.pdesc>>       ,         .";
			exit;
		}
		pass ioPutOn;
	}
	islocked = true //   
	//  
	lock =
	{
		local lock := self.islocked;
		//    
		if(goldPivot.location = roundHole && brassPivot.location = triangularHole && copperPivot.location = squareHole && ironPivot.location = squareHole)
			self.islocked := nil;
		else
			self.islocked := true;
		//   
		if(self.islocked != lock)
		{
			if(self.islocked)
			{
				field.moveInto(self);
				"\n    ";
			}
			else
			{
				field.moveInto(nil);
				"\n    .";
			}
		}
	}
	noun = '/1' '/1' '/1' '/1' '/1'
	adjective = '/1' '/1' '/1'
	isHim = true
;

field: fixeditem
	desc = '/1 /1'
	ldesc = "  ,         ,   ."
	touchdesc = "  <<self.sdesc>> ,   ."
	verDoKnock(actor) =
	{
		"    <<self.ddesc>>,      .";
	}
	noun = '/1'
	adjective = '/1' '/1' '/1' '/- /1' '/1' '/1' '/1'
	location = pedestal
;

roundHole: hole
	desc = '/1 /1'
	ldescText = '  '
	ioPutIn(actor, dobj) =
	{
		if(!isclass(dobj, pivot))
		{
			"<<ZAG(dobj, &sdesc)>>    .     -   .";
		}
		else
		{
			if(dobj = silverPivot)
			{
				"<<ZAG(dobj, &sdesc)>>    <<self.vdesc>>,        .";
				exit;
			}
			if(length(self.contents) > 0)
			{
				"<<ZAG(dobj, &sdesc)>>    <<self.vdesc>>,      <<self.contents[1].tdesc>>.";
				exit;
			}
			pass ioPutIn;
		}
	}
	adjective = '/1' '/1'
	location = pedestal
;

triangularHole: hole
	desc = '/1 /1'
	ldescText = '  '
	ioPutIn(actor, dobj) =
	{
		if(!isclass(dobj, pivot))
		{
			"<<ZAG(dobj, &sdesc)>>    .     -   .";
		}
		else
		{
			if(dobj = silverPivot)
			{
				"<<ZAG(dobj, &sdesc)>>    <<self.vdesc>>,        .";
				exit;
			}
			if(dobj = goldPivot)
			{
				"<<ZAG(dobj, &sdesc)>>    <<self.vdesc>>,        .";
				exit;
			}
			if(length(self.contents) > 0)
			{
				"<<ZAG(dobj, &sdesc)>>    <<self.vdesc>>,      <<self.contents[1].tdesc>>.";
				exit;
			}
			pass ioPutIn;
		}
	}
	adjective = '/1' '/1'
	location = pedestal
;

squareHole: hole
	desc = '/1 /1'
	ldescText = '  '
	ioPutIn(actor, dobj) =
	{
		if(!isclass(dobj, pivot))
		{
			"<<ZAG(dobj, &sdesc)>>    .     -   .";
		}
		else
		{
			if(dobj = silverPivot)
			{
				"<<ZAG(dobj, &sdesc)>>    <<self.vdesc>>,      .";
				exit;
			}
			if(dobj = goldPivot)
			{
				"<<ZAG(dobj, &sdesc)>>    <<self.vdesc>>,        .";
				exit;
			}
			if(length(self.contents) > 0 && !((dobj = copperPivot || dobj = ironPivot) && (self.contents[1] = copperPivot || self.contents[1] = ironPivot)))
			{
				"<<ZAG(dobj, &sdesc)>>    <<self.vdesc>>,      <<self.contents[1].tdesc>>";
				if(length(self.contents) > 1)
					"  <<self.contents[2].tdesc>>.";
				else
					".";
				exit;
			}
			pass ioPutIn;
		}
	}
	adjective = '/1' '/1'
	location = pedestal
;

eye: seethruItem
	desc = '/1 /-'
	ldesc = "    ,       ,  ,     ."
	thrudesc =
	{
		deadlyEye(parserGetMe());
	}
	// " " = " "
	doSynonym('Lookthru') = 'Lookin'
	dobjGen(a, v, i, p) =
	{
		if(self.location = pedestal && pedestal.islocked)
		{
			if (v <> askVerb and v <> tellVerb and v <> inspectVerb && v <> osmVerb)
			{
				"      ,   .";
				exit;
			}
		}
		else
		{
			pass dobjGen;
		}
	}
	iobjGen(a, v, d, p) =
	{
		if(self.location = pedestal && pedestal.islocked)
			self.dobjGen(a, v, d, p);
		else
			pass iobjGen;
	}
	noun = '/1' '/1' '/1' '/1'
	adjective = '/1' '/1'
	isHim = true
	location = pedestal
;